---
Name: Goodboy Galaxy: Chapter Zero: Demo
Creator: Rik Nicol|Jeremy Clarke
Category: Games
---
<style type="text/css">
* {
  box-sizing: border-box;
}

body {
  background-image: url(https://goodboygalaxy.com/space.jpg);
  background-size: 100%;
  background-attachment: fixed;
  font-family: "Nunito", sans-serif;
  color: #ffffff;
  background-color: #412766;
  max-width: 100%;
  position: relative;
  margin: 0;
  padding: 0;
}

b {
  font-weight: bold;
}

p {
  margin: 1em 0;
}

.secondaryText {
  color: #b297f8;
}

#maxwellGBA {
  width: 324px;
  float: right;
}

#screenshot {
  width: 480px;
  border-radius: 4px;
  margin-right: 1.5em;
  margin-bottom: 1em;
  box-sizing: content-box;
}

.pageTop {
  width: 1200px;
  max-width: 100%;
  background-color: rgba(238, 48, 66, 0.66);
  padding: 1em;
  font-weight: 900;
  margin-left: auto;
  margin-right: auto;
  border-radius: 2em 2em 0 0;
  text-transform: uppercase;
  text-align: center;
}

.pageTop, h2 {
  font-size: 20px;
}

.floatLeft {
  float: left;
}

.pageBottom {
  width: 1200px;
  max-width: 100%;
  background-color: rgba(32, 5, 43, 0.66);
  padding: 2em;
  font-size: 1.3em;
  line-height: 1.3em;
  margin-left: auto;
  margin-right: auto;
  border-radius: 0 0 4em 4em;
  box-sizing: border-box;
  text-align: left;
}

.roundSection, .fullSection, .section {
  padding: 2em;
}

.fullSection {
  font-size: 0;
  background: rgba(32, 5, 43, 0.66);
  text-align: center;
  padding: 2px;
}
.fullSection img {
  width: 480px;
  padding: 2px;
  max-width: calc(100% - 2px);
}

.question {
  font-weight: bold;
}

a, a:hover, a:active {
  color: #FFFFFF;
  font-weight: bold;
  text-decoration: none;
}

.centerAlign {
  text-align: center;
}

#kickstarterLink {
  display: inline-block;
  text-align: center;
  width: 300px;
  max-width: 90vw;
  background-color: rgba(43, 5, 25, 0.565);
  padding: 5px;
  border-radius: 18px;
  vertical-align: bottom;
}
#kickstarterLink img {
  max-width: 90%;
}

#content > h1, #content > p {
display: none;
}

#friendSprites {
  width: 768px;
}
</style>

<link href="https://fonts.googleapis.com/css2?family=Nunito:wght@400;900&amp;display=swap" rel="stylesheet"/>
<div class="roundSection">
  <div class="pageTop">ABOUT GOODBOY GALAXY</div>
  <div class="pageBottom"><img class="floatLeft" id="screenshot" src="https://goodboygalaxy.com/screenshot2.gif"/><span><b>Goodboy Galaxy</b> is a game in development for <b>Game Boy Advance</b>, PC and Nintendo Switch.  It&apos;s an exploration focused platform game similar to Metroid or Cave Story.</span>
    <p class="secondaryText">With his home world on the brink of ecological collapse, <b>Maxwell</b> bravely hopped into his experimental ship in dogged pursuit of a solution.<br/><br/>&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;Beyond the point of no return, holding out forlorn hope, he finds himself stranded - thousands of lightyears from home, at the edge of a hostile galaxy.<br/><br/>&#x9;&#x9;&#x9;&#x9;&#x9;&#x9;Help <b>Maxwell</b> explore unfamiliar worlds, make strange new friends and contend with mysterious forces.</p><span>
      <h2><b>GAME FEATURES</b></h2>
      <ul>
        <li>Explore jam-packed levels with multiple routes</li>
        <li>Meet 50 characters, and collect their friendship cards</li>
        <li>Uncover secret areas hidden away</li>
        <li>Discover a wide array of beasties to blast</li>
        <li>Explore the galaxy, jumping between planets in your ship</li>
        <li>Upgrade your blaster with special abilities</li>
        <li>Cutting edge 0.2K (240x160) graphics</li>
      </ul></span>
  </div>
</div>
<div class="fullSection screenshots"><img src="https://goodboygalaxy.com/screenshots/ss12.png" alt="Goodboy Galaxy screenshot"/><img src="https://goodboygalaxy.com/screenshots/ss02.png" alt="Goodboy Galaxy screenshot"/><img src="https://goodboygalaxy.com/screenshots/ss07.png" alt="Goodboy Galaxy screenshot"/><img src="https://goodboygalaxy.com/screenshots/ss05.png" alt="Goodboy Galaxy screenshot"/><img src="https://goodboygalaxy.com/screenshots/ss06.png" alt="Goodboy Galaxy screenshot"/><img src="https://goodboygalaxy.com/screenshots/ss01.png" alt="Goodboy Galaxy screenshot"/></div>
<div class="roundSection">
  <div class="pageTop">FREQUENTLY ASKED QUESTIONS</div>
  <div class="pageBottom">
    <div class="question"><span class="secondaryText">Q. </span><span>Why GBA?</span></div>
    <div class="answer"><span class="secondaryText">We’re celebrating our 20 year old friend, the Game Boy Advance, because we think it’s fun / interesting!</span></div><br/>
    <div class="question"><span class="secondaryText">Q. </span><span>Will there be a &lt;Switch&gt;/&lt;Xbox&gt;/&lt;PS5&gt; port?</span></div>
    <div class="answer"><span class="secondaryText">We really want to do an enhanced port (modern aspect ratio, HQ audio etc), it just depends on the crowdfunding success!</span></div><br/>
    <div class="question"><span class="secondaryText">Q. </span><span>Who are you?</span></div>
    <div class="answer"><span class="secondaryText"><a href="https://www.twitter.com/hot_pengu">@hot_pengu</a> and <a href="https://www.twitter.com/exelotl">@exelotl</a> (with a little help from our friends)</span></div><br/>
    <div class="question"><span class="secondaryText">Q. </span><span>Why GBA?</span></div>
    <div class="answer"><span class="secondaryText">We’re celebrating our 20 year old friend, the Game Boy Advance, because we think it’s fun / interesting!</span></div>
    <img id="friendSprites" src="https://goodboygalaxy.com/friend-sprites.gif">
  </div>
</div>
<div class="fullSection screenshots"> <img src="https://goodboygalaxy.com/screenshots/ss08.png" alt="Goodboy Galaxy screenshot"/><img src="https://goodboygalaxy.com/screenshots/ss09.png" alt="Goodboy Galaxy screenshot"/><img src="https://goodboygalaxy.com/screenshots/ss10.png" alt="Goodboy Galaxy screenshot"/><img src="https://goodboygalaxy.com/screenshots/ss13.png" alt="Goodboy Galaxy screenshot"/><img src="https://goodboygalaxy.com/screenshots/ss17.png" alt="Goodboy Galaxy screenshot"/><img src="https://goodboygalaxy.com/screenshots/ss04.png" alt="Goodboy Galaxy screenshot"/></div>
<div class="centerAlign section"><a id="kickstarterLink" href="https://www.kickstarter.com/projects/penguinrik/goodboy-galaxy-exploration-platform-game-gba-pc-and-switch"><span>Thank you for reading,<br/>please support us on:</span><img src="https://goodboygalaxy.com/kickstarter.svg"/></a></div>